<template>
 <v-page>
   <div v-show="changed">
     <font-awesome-icon icon="check-circle" class="icon-success"/>
     <br/>
     <div class="text">Password changed</div>
   </div>
   <div v-show="!changed">
     <InputNewPass
         v-model="newPass"
         :disabled="inProgress"
         :pass-complexity-calculator="passComplexityCalculator"
         ref="newPassInput"
         @input="onInput"
         @keyup-enter="onSavePass"
     />
     <FormErrorMessage v-show="error">{{ error }}</FormErrorMessage>
     <br/>
     <v-button :in-progress="inProgress" @click="onSavePass">Save</v-button>
   </div>
  </v-page>
</template>

<script>
  import { FontAwesomeIcon } from '@fortawesome/vue-fontawesome'
  import { library } from '@fortawesome/fontawesome-svg-core'
  import { faCheckCircle } from '@fortawesome/free-solid-svg-icons'
  import { createNamespacedHelpers } from 'vuex'

  import { animateError, getPassComplexity, PassComplexity, VPage } from 'zeus-common'
  import VButton from 'zeus-common/src/component/button/VButton'
  import FormErrorMessage from 'zeus-common/src/component/input/FormErrorMessage'
  import { ConfirmingEmailError } from '@/pages/confirming-email/service'
  import InputNewPass from 'zeus-common/src/component/input/InputNewPass'
  import { ChangePassError } from '@/pages/change-pass/service'

  library.add(faCheckCircle)

  const { mapState } = createNamespacedHelpers('changePass')

  export default {
    name: 'ChangePassPage',
    components: { InputNewPass, FormErrorMessage, VButton, FontAwesomeIcon, VPage },
    props: {
      token: String
    },
    data: () => ({
      newPass: { pass: '', passConfirmation: '' },
      ConfirmingEmailError: ConfirmingEmailError
    }),
    computed: {
      ...mapState([ 'inProgress', 'error', 'changed' ])
    },
    watch: {
      error(error) {
        if (error === ChangePassError.PASSWORDS_ARE_DIFFERENT) {
          animateError(this.$refs.newPassInput.$refs.passInput)
          animateError(this.$refs.newPassInput.$refs.passConfirmationInput)
        }
      }
    },
    methods: {
      passComplexityCalculator: getPassComplexity,
      onInput() {
        if (this.error) {
          this.$store.commit('changePass/resetError')
        }
      },
      onSavePass() {

        this.onInput()

        let errorCounter = 0

        if (!this.newPass.pass || this.newPass.complexity === PassComplexity.Low) {
          animateError(this.$refs.newPassInput.$refs.passInput)
          errorCounter++
        }
        if (!this.newPass.passConfirmation) {
          animateError(this.$refs.newPassInput.$refs.passConfirmationInput)
          errorCounter++
        }

        if (errorCounter === 0) {
          this.$store.dispatch('changePass/changePass', {
            token: this.token,
            pass: this.newPass.pass,
            passConfirmation: this.newPass.passConfirmation
          })
        }
      }
    }
  }
</script>

<style scoped lang="scss">
  @import "~zeus-common/src/component/color";

  .icon-success {
    color: $color-success;
    font-size: 2.5em;
    margin-top: 0.5em;
    margin-bottom: 0.5em;
  }

  .text {
    margin-bottom: 1em;
  }
</style>